#include <iostream>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <windows.h>

#define GREEN 0
#define BLUE 1
#define YELLOW 2
#define RED 3
#define BLACK 4
#define WHITE 5

#define ABORT 1
#define DETONATE 2
#define HOLD 3

#define P_R 0
#define H_R 1

#define POSITION 0
#define NUMBER 1

using namespace std;

int last_odd = 0;
int has_vowel = 0;
int seconds = 70;
int ticks = 0; 
int strikes = 0;
char ser_num[6]; 
int ind_num;
int batteries;
int car_lit = 0;
int frk_lit = 0;
int print_time = 0;
// [vowel] [strike] [colour]
int simon_says_pattern[2][3][4] = {GREEN, YELLOW, RED, BLUE, YELLOW, BLUE, GREEN , RED, BLUE, GREEN, RED ,YELLOW, YELLOW, RED, GREEN, BLUE, BLUE, GREEN, RED , YELLOW, YELLOW, RED, BLUE, GREEN};

char indicators[10][4] = {"FRK", "CAR", "SIG", "NSA", "MSA", "FRQ", "BOB", "TRN", "CLR", "CRT"};

DWORD WINAPI timer(CONST LPVOID lpParam)
//void timer()
{
	//HANDLE hStdout = GetStdHandle(STD_OUTPUT_HANDLE);
	//char output[7] = "00:00\n";
	//DWORD a;
	//HANDLE x = GetStdHandle(STD_OUTPUT_HANDLE);
	//size_t b = sizeof(output)/sizeof(char);
	ticks = clock();
	while(seconds != 0)
	{
		
		if(ticks == clock())
		{
			ticks += (1000 - 200*strikes);
			seconds--;
			if(print_time)
			{
				printf("%d:%d\n", (seconds / 60), (seconds % 60));
				//WriteConsole(x, output, b, &a, NULL);
			}
		}
	}
}

struct indicator
{
	char name[3];
	int lit;
};

indicator inds[4];

void ser_num_create()
{ 
	ser_num[5] = rand() % 10 + 48;
	if((ser_num[5] % 2))
		last_odd = 1;
	ser_num[1] = rand() % 26 + 65;
	for(int i = 0; i < 4; i++)
	{
		int k = 0;
		if(i)
			k = 1;
		if(rand() % 2)
		{
			ser_num[i+k] = rand() % 26 + 65;
		}
		else
		{
			ser_num[i+k] = rand() % 10 + 48;
		}
		for(int i = 0; i < 6; i++)
		{
			if((ser_num[i] == 65) || (ser_num[i] == 69) || (ser_num[i] == 73) || (ser_num[i] == 79) || (ser_num[i] == 85))
				has_vowel = 1;
		}
	}
}

struct wires
{
	int colour;
	int cut;
};

class module
{
	public:
	int solved;
	int answer;
	int tried;
	
	//simple_wires
	int wires_num;
	wires w[6];
	
	//button
	int colour;
	int name;
	
	//simon_says
	int sequence[6];
	int seq_length;
	int cur_beat;
	
	//memory
	int stage;
	int answer_type;
	int screen_number;
	int button_numbers[4];
	int previous_stages[][2];
	
	int virtual right_answer()
	{
		
	}
	
	int virtual solve_interface()
	{
		
	}
	
	virtual ~module()
	{
		cout << "mod" << endl;
	}
};


class memory: public module
{
	public:
	memory()
	{
		stage = 1;
		tried = 1;
		solved = 0;
	}
	
	virtual ~memory()
	{
		cout << "mem" << endl;
	}
	
	int solve_interface()
	{
		while(stage != 6)
		{
			if(tried)
			{
				screen_number = rand() % 4 + 1;
				for(int i = 0; i < 4; i++)
				{
					int bak = rand() % 4 + 1;
					int additional = 0;
					for(int j = 0; j <  i; j++)
					{
						if(button_numbers[j] == bak)
						{
							bak = (bak % 4) + 1;
							j = -1;
						}
					}
					button_numbers[i] = bak;
				}
			}
			tried = 0;
		
			switch(stage)
			{
				case 1:
				{
					answer_type = POSITION;
					if((screen_number == 1) || (screen_number == 2))
						answer = 2;
					if(screen_number == 3)
						answer = 3;
					if(screen_number == 4)
						answer =4;
					break;
				}
				
				case 2:
				{
					answer_type = POSITION;
					if((screen_number == 4) || (screen_number == 2))
						answer = previous_stages[0][POSITION];
					if(screen_number == 1)
					{
						answer = 4;
						answer_type = NUMBER;
					}
					if(screen_number == 3)
						answer =1;
					break;
				}
				
				case 3:
				{	
					answer_type = NUMBER;
					if(screen_number == 1)
						answer = previous_stages[1][NUMBER];
					if(screen_number == 2)
						answer = previous_stages[0][NUMBER];
					if(screen_number == 3)
					{
						answer = 3;
						answer_type = POSITION;
					}
					if(screen_number == 4)
						answer =4;
					break;
				}
			
				case 4:
				{
					answer_type = POSITION;
					if(screen_number == 1)
						answer = previous_stages[0][POSITION];
					if(screen_number == 2)
						answer = 1;
					if((screen_number == 3) || (screen_number == 4))
					{
						answer = previous_stages[1][POSITION];
					}
					break;
				}
				
				case 5:
				{
					answer_type = NUMBER;
					if(screen_number == 1)
						answer = previous_stages[0][NUMBER];
					if(screen_number == 2)
						answer = previous_stages[1][NUMBER];
					if(screen_number == 3)
						answer = previous_stages[3][NUMBER];
					if(screen_number == 4)
						answer = previous_stages[2][NUMBER];
					break;
				}
			}
			//system("cls");
			
			
			cout << "strikes: " << strikes << endl;
			cout << "stage: " << stage << endl;
			cout << "answer_type: " << answer_type << endl;
			cout << "answer: " << answer << endl;
			cout << "prev_pos: " << previous_stages[stage-2][POSITION] << endl;
			cout << "prev_num: " << previous_stages[stage-2][NUMBER] << endl;
			 
			
			
			cout << "screen" << endl;
			cout << "| " << screen_number << " |" << endl << endl;
			cout << "buttons" << endl;
			cout << "| ";
			for(int i = 0; i < 4; i++)
			{
				cout << button_numbers[i] << " | ";
			}
			cout << endl << endl;
			cout << "type button position" << endl;
			char player_answer;
			//scanf("%c", &player_answer);
			cin >> player_answer;
			cout << endl;
			if(player_answer == 'q')
				return 0;
			tried = 1;
			switch(answer_type)
			{
				case POSITION:
					if(((int)player_answer - 48) == answer)
					{
						previous_stages[stage - 1][POSITION] = answer;
						previous_stages[stage - 1][NUMBER] = button_numbers[answer - 1];
						stage++;
					}
					else
					{
						strikes++;
						stage = 1;
					}
					break;
				case NUMBER:
					if(button_numbers[(int)player_answer - 49] == answer)
					{
						previous_stages[stage-1][POSITION] = (int)player_answer - 48;
						previous_stages[stage-1][NUMBER] = answer;
						stage++;
					}
					else
					{
						strikes++;
						stage = 1;
					}
					break;
						
			}
		}
		return 1;
	}
};

class simon_says: public module
{
	public:
	simon_says()
	{
		cur_beat = 0;
		solved = 0;
		seq_length = rand() % 4 + 3;
		for(int i = 0; i < seq_length; i++)
		{
			sequence[i] = rand() % 4;
		}
	}
}; 

class button: public module
{
	public:
	button()
	{
		solved = 0;
		colour = rand() % 4 + 1;
		name = rand() % 3 + 1;
		answer = right_answer();
	}
	
	int right_answer()
	{
		if((colour == BLUE) && (name == ABORT))
			return H_R;
		
		if((batteries > 1) && (name = DETONATE))
			return P_R;
			
		if((car_lit) && (colour == WHITE))
			return H_R;
			
		if((frk_lit) && (batteries > 2))
			return P_R;
			
		if(colour == YELLOW)
			return H_R;
		 
		if((colour == RED) && (name == HOLD))
			return P_R;
		
		return H_R;
	}
	
	int solve_interface()
	{
		
	}
};

class simple_wires: public module
{
	public:
	simple_wires()
	{
		solved = 0;
		wires_num = rand() % 4 + 3;
		/*
			blue = 1
			yellow = 2
			red = 3
			black = 4
			white = 5
		*/
		
		for(int i = 0; i < wires_num ; i++)
		{
			w[i].colour = rand() % 5 + 1;
			w[i].cut = 0;
		}
		answer = right_answer();
	}
	
	int right_answer()
	{
		switch(wires_num)
		{
			case 3:
			{
				int no_red = 1;
				for(int i = 0; i < 3; i++)
				{
					if(w[i].colour == RED)
						no_red = 0;
				}
				if(no_red)
					return 2;
				
				if(w[2].colour == WHITE)
					return 3;
				
				int blue_num = 0;
				int last_blue;
				for(int i = 0; i < 3; i++)
				{
					if(w[i].colour == BLUE)
					{
						blue_num++;
						last_blue = i + 1;
					}
				}
				if(blue_num > 1)
					return last_blue;				
				return 3;
				break;
			}
			case 4:
			{
				int red_num = 0, blue_num = 0, yel_num = 0;
				int last_red, i;
				for(i = 0; i < 4; i++)
				{
					if(w[i].colour == RED)
					{
						red_num++;
						last_red = i + 1;
					}
					if(w[i].colour == BLUE)
					{
						blue_num++;
					}
					if(w[i].colour == YELLOW)
					{
						yel_num++;
					}
				}
				if((red_num > 1) && (last_odd))
					return last_red;
				if((!red_num) && (w[3].colour == YELLOW))
					return 1;
				if(blue_num == 1)
					return 1;
				if(yel_num > 1)
					return 4;
				return 2;
			}
			case 5:
			{
				if((w[4].colour == BLACK) && (last_odd))
					return 4;
				int red_num = 0, black_num = 0, yel_num = 0;
				for(int i = 0; i < 4; i++)
				{
					if(w[i].colour == RED)
					{
						red_num++;
					}
					if(w[i].colour == BLACK)
					{
						black_num++;
					}
					if(w[i].colour == YELLOW)
					{
						yel_num++;
					}
				}
				
				if((red_num == 1) && (yel_num > 1))
					return 1;
				if(!black_num)
					return 2;
				return 1;
			}
			case 6:
			{
				int red_num = 0, white_num = 0, yel_num = 0;
				for(int i = 0; i < 4; i++)
				{
					if(w[i].colour == RED)
					{
						red_num++;
					}
					if(w[i].colour == WHITE)
					{
						white_num++;
					}
					if(w[i].colour == YELLOW)
					{
						yel_num++;
					}
				}
				if((!yel_num) && (last_odd))
					return 3;
				if((yel_num == 1) && (white_num > 1))
					return 4;
				if(!red_num)
					return 6;
				return 4;
			}
		}
	}
};

int main()
{
	srand(time(NULL));
	batteries = rand() % 6;
	ind_num = rand() % 4;
	int ind_used[2];
	int ind_used_stack = 0;
	module *p;
	for(int i = 0; i < ind_num; i++)
	{
		int bak;
		random: bak = rand() % 9;
		for(int j = 0; j < ind_used_stack; j++)
		{
			if(bak == ind_used[j])
				goto random;
		}
		ind_used[ind_used_stack] = bak;
		ind_used_stack++;
		strcpy(inds[i].name, indicators[bak]);
		inds[i].lit = rand() % 2;
		if((inds[i].name == "CAR") && (inds[i].lit))
			car_lit = 1;
		if((inds[i].name == "FRK") && (inds[i].lit))
			frk_lit = 1;
	}
	ser_num_create();
	cout << "serial number: " << ser_num << endl;
	cout << "is last number odd?: " << last_odd << endl;
	cout << "is there a vowel: " << has_vowel << endl;
	cout << "batteries: " << batteries << endl;
	cout << "indicators:" << ind_num << endl;
	for(int i = 0; i < ind_num; i++)
	{
		cout << inds[i].name << " " << inds[i].lit << endl;
	}
	
	
	
	//timer thread
	/*
	CONST HANDLE hMutex = CreateMutex(NULL, FALSE, NULL);
	HANDLE thr;
	int a = 0;
	thr = CreateThread(NULL, 0, timer, &a, 0, NULL);
	*/
	
	
	//memory test
	
	p = new memory;

	
	p->solved = p->solve_interface();

	
	cout << p->solved << endl;

	delete p;
	
	puts("kek");
	
	
	
	//simon_says test
	/*
	p = new simon_says;
	cout << p->seq_length << endl;
	cout << p->cur_beat << endl;
	for(int i = 0; i < p->seq_length; i++)
	{
		cout << p->sequence[i] << " " << simon_says_pattern[has_vowel][strikes][p->sequence[i]] << endl;
	}
	*/
	
	//button test
	/*
	p = new button;
	cout << p->name << endl;
	cout << p->colour << endl;
	cout << p->answer << endl;
	*/

	//wires test
	/*
	p = new simple_wires;
	cout << p->solved << endl << p->wires_num << endl;
	for(int i = 0; i < p->wires_num; i++)
	{
		cout << p->w[i].colour << " " << p->w[i].cut << endl;
	}
	cout << p->answer << endl;
	*/
	
	
	// time test
	
	/*
	while(seconds != 30)
	{
		if(seconds == 10)
		{
			strikes = 1;;
		}
		
		if(seconds == 20)
		{
			strikes = 2;;
		}
		
		if(ticks == clock())
		{
			ticks += (1000 - 200*strikes);
			seconds++;
			printf("%d %d %d\n", clock(), ticks, seconds);
		}
	}
	*/
	return 0;
}